<?php

namespace App\Livewire\Studio\Feature;

use App\Livewire\Forms\Studio\Feature\ChooseUsForm;
use App\Models\ChooseUs as ChooseUsModel;
use App\Traits\Authorization\WithAuthorization;
use App\Traits\Components\WithCloseModal;
use App\Traits\Components\WithConfirmation;
use App\Traits\Components\WithToast;
use App\Traits\Notification\WithSubscribeNotification;
use App\Traits\Utilities\WithUpdatedData;
use Flux\Flux;
use Illuminate\Contracts\View\View;
use Livewire\Attributes\On;
use Livewire\Attributes\Title;
use Livewire\Component;

#[Title('Pilih Kami')]
class ChooseUs extends Component
{
    use WithAuthorization, WithCloseModal, WithConfirmation, WithSubscribeNotification, WithToast, WithUpdatedData;

    public ChooseUsForm $form;

    public string $method = 'create';

    public string $modalTitle = '';

    public function create(): void
    {
        $this->canOrAbort('create choose us');

        $this->form->store();

        $this->dispatch('refreshDatatable');

        $this->toast('Pilih kami berhasil ditambahkan.');

        Flux::modals()->close();
    }

    public function update(): void
    {
        $this->canOrAbort('update choose us');

        $this->form->update();

        $this->dispatch('refreshDatatable');

        $this->toast('Pilih kami berhasil diperbarui.');

        Flux::modals()->close();
    }

    public function delete(ChooseUsModel $chooseUs): void
    {
        $this->canOrAbort('delete choose us');

        $this->form->chooseUs = $chooseUs;

        $this->form->delete();

        $this->dispatch('refreshDatatable');

        $this->toast('Pilih kami berhasil dihapus.');

        Flux::modals()->close();
    }

    #[On('fn:sortOrder')]
    public function sortOrder(ChooseUsModel $chooseUs, string $direction): void
    {
        $this->canOrAbort('update choose us');

        $this->form->chooseUs = $chooseUs;

        $this->form->sortOrder($direction);

        $this->dispatch('refreshDatatable');
    }

    #[On('modal:open')]
    public function openModal(string $method, string $modalTitle, ?string $id = null): void
    {
        $this->resetValidation();
        $this->resetErrorBag();

        $this->method = $method;
        $this->modalTitle = $modalTitle;

        $id && $this->form->setChooseUs(ChooseUsModel::byHashOrFail($id));
    }

    public function render(): View
    {
        return view('livewire.studio.feature.choose-us', [
            'pageTitle' => 'Pilih Kami',
        ]);
    }
}
